#include <stdio.h>
#include "vm.h"
#include "disk.h"
#include "pagetable.h"

PT pageTable;
FRAME frame_table[NUM_FRAME];
TLB tlb[NUM_PROC][TLB_ENTRY/2];

char* bool2char(bool b)
{
		if(b) return "hit";
		else return "miss";
}

void print_result(int pid, char type, bool tlb_hit, bool page_hit, int virtual_addr, int physical_addr)
{
		printf("[pid %d, %c] TLB:%s, Page:%s, 0x%x -> 0x%x\n", pid, type, bool2char(tlb_hit), bool2char(page_hit), virtual_addr, physical_addr);
}

int MMU(int pid, int addr, char type)
{
		int frameNo;
		int pageNo = (addr >> 8);
		int offset = addr - (pageNo << 8);
		int physicalAddr;
		
		if(pageNo > NUM_PAGE) {
				printf("invalid page number (NUM_PAGE = 0x%x): pid %d, addr %x\n", NUM_PAGE, pid, addr);
				return -1;
		}
		if(pid > NUM_PROC-1) {
				printf("invalid pid (NUM_PROC = %d): pid %d, addr %x\n", NUM_PROC, pid, addr);
				return -1;
		}



		/* ---- */


		return physicalAddr;
}

void pt_print_stats()
{
		int req = pageTable.stats.hitCount + pageTable.stats.missCount;
		int hit = pageTable.stats.hitCount;
		int miss = pageTable.stats.missCount;
		int tlbHit = pageTable.stats.tlbHitCount;
		int tlbMiss = pageTable.stats.tlbMissCount;

		printf("Request: %d\n", req);
		printf("Page Hit: %d (%.2f%%)\n", hit, (float) hit*100 / (float)req);
		printf("Page Miss: %d (%.2f%%)\n", miss, (float)miss*100 / (float)req);
		printf("TLB Hit: %d (%.2f%%)\n", tlbHit, (float) tlbHit*100 / (float)req);
		printf("TLB Miss: %d (%.2f%%)\n", tlbMiss, (float) tlbMiss*100 / (float)req);

}

void pt_init()
{
		int i,j;

		pageTable.stats.hitCount = 0;
		pageTable.stats.missCount = 0;
		pageTable.stats.tlbHitCount = 0;
		pageTable.stats.tlbMissCount = 0;

		for(i = 0; i < NUM_PROC; i++) {
				for(j = 0; j < NUM_PAGE; j++) {
						pageTable.entry[i][j].valid = false;
				}
		}
}

void tlb_init()
{
		int i, j;
		for (i = 0; i < NUM_PROC; i++)
		{
				for(j = 0; j < TLB_ENTRY / 2; j++)
				{
						tlb[i][j].valid[0] = tlb[i][j].valid[1] = false;
						tlb[i][j].lru = 0;
				}
		}
}

